unit dm_data;

interface

uses
  SysUtils, Classes, Dialogs, Controls, DB, DBTables, PropSaveMain,
  Provider, DBClient, DBLocal, DBLocalB;

type
  TData = class(TDataModule)
    dsEmployee: TDataSource;
    dsCustomer: TDataSource;
    dsFirms: TDataSource;
    Session1: TSession;
    Database1: TDatabase;
    tEmployee: TBDEClientDataSet;
    tEmployeeEmpNo: TIntegerField;
    tEmployeeLastName: TStringField;
    tEmployeeFirstName: TStringField;
    tEmployeePhoneExt: TStringField;
    tEmployeeHireDate: TDateTimeField;
    tEmployeeSalary: TFloatField;
    tEmployeeMemo: TMemoField;
    tEmployeePhoto: TGraphicField;
    tEmployeeRetired: TBooleanField;
    tCustomer: TBDEClientDataSet;
    qFirms: TBDEClientDataSet;
    tCustDetail: TBDEClientDataSet;
    tCustomerCustNo: TFloatField;
    tCustomerFirmNo: TIntegerField;
    tCustomerAddr1: TStringField;
    tCustomerPhone: TStringField;
    tCustomerFAX: TStringField;
    tCustomerTaxRate: TFloatField;
    tCustomerContact: TStringField;
    tCustomerLastInvoiceDate: TDateTimeField;
    qFirmsFirmNo: TIntegerField;
    qFirmsFirmName: TStringField;
    tCustDetailCustNo: TFloatField;
    tCustDetailFirmNo: TIntegerField;
    tCustDetailAddr1: TStringField;
    tCustDetailPhone: TStringField;
    tCustDetailFAX: TStringField;
    tCustDetailTaxRate: TFloatField;
    tCustDetailContact: TStringField;
    tCustDetailLastInvoiceDate: TDateTimeField;
    tCustomerFirmName: TStringField;
    procedure tEmployeeBeforeClose(DataSet: TDataSet);
    procedure tEmployeeBeforeDelete(DataSet: TDataSet);
    procedure tEmployeePostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure dsEmployeeStateChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function OpenTables: boolean;
    function CloseTables: boolean;
  end;

var
  Data: TData;

implementation

{$R *.dfm}

uses rstring, rdlg, rtool, rdbtool, rdbtool_BDE, f_main;

function TData.OpenTables: boolean;
var s: string;
begin
  s:=GetAppPath+'Data\';

  Session1.Close;
  Session1.PrivateDir:=s;
  Session1.NetFileDir:=s;
  SetAliasPath(Session1,Database1.DatabaseName,s,true);

  Result:=false;
  try
    tEmployee.Close;
    tCustomer.Close;
    qFirms.Close;

    tEmployee.Open;
    tCustomer.Open;
    qFirms.Open;

    Result:=true;
    Main.SBar.SimpleText:=sDBFile+s+'Employee.db';
  except
    on E: Exception do ShowErr('',E,false);
  end;
end;

function TData.CloseTables: boolean;
begin
  Result:=false;
  Main.SBar.SimpleText:=sDBFile+'none';
  try
    tEmployee.Close;
    tCustomer.Close;
    qFirms.Close;
    Result:=true;
  except
    on E: Exception do ShowErr('',E,false);
  end;
end;

procedure TData.tEmployeeBeforeClose(DataSet: TDataSet);
begin
  (DataSet as TBDEClientDataSet).ApplyUpdates(1);
end;

procedure TData.tEmployeeBeforeDelete(DataSet: TDataSet);
begin
  if DlgQ(sDelRecordQ)<>mrYes then Abort;
end;

procedure TData.tEmployeePostError(DataSet: TDataSet; E: EDatabaseError;
  var Action: TDataAction);
begin
  ShowErr(sSaveRecordErr,E,false);
  Action:=daAbort;
end;

procedure TData.dsEmployeeStateChange(Sender: TObject);
begin
  Main.grEmp2.Enabled:=not IsEditing(tEmployee);
end;

end.
